/*
 * This file is part of the QPxTool project.
 * Copyright (C) 2005-2009 Gennady "ShultZ" Kozlov <qpxtool@mail.ru>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
//#include <sys/time.h>

#include <qpx_transport.h>
#include <qpx_mmc.h>
#include <common_functions.h>

#include <qscan_plugin.h>

//#define _BENQ_DEBUG 1
#define _BENQ_DEBUG2 1

// ************* Scan init commands *********
int scan_benq::cmd_cd_errc_init()
{
	int i;

	dev->cmd[0] = 0xFD;
	dev->cmd[1] = 0xF1;
	dev->cmd[2] = 0x42;
	dev->cmd[3] = 0x45;
	dev->cmd[4] = 0x4E;
	dev->cmd[5] = 0x51;
#ifdef _BENQ_DEBUG
	printf("benq_init_cx_scan_0\n");
#endif
	if ((dev->err=dev->cmd.transport(NONE,NULL,0))){
		if(!dev->silent) sperror ("benq_init_cx_scan_0",dev->err);
		return dev->err;
	}
// ************
	dev->rd_buf[0] = 0xD2;
	dev->rd_buf[1] = 0x0A;
	dev->rd_buf[2] = 0x00;
	dev->rd_buf[3] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x04;
#ifdef _BENQ_DEBUG
	printf("benq_init_cx_scan_1\n");
#endif
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,4))){
		if(!dev->silent) sperror ("benq_init_cx_scan_1",dev->err);
		return dev->err;
	}

	dev->cmd[0] = 0xF8;
	dev->cmd[8] = 0x02;
#ifdef _BENQ_DEBUG
	printf("benq_init_cx_scan_2\n");
#endif
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,2))){
		if(!dev->silent) sperror ("benq_init_cx_scan_2",dev->err);
		return dev->err;
	}
// ************
	dev->rd_buf[0] = 0xC8;
	dev->rd_buf[1] = 0x99;
	dev->rd_buf[2] = 0x79;
	for (i=3; i<10; i++)
		dev->rd_buf[i] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x0A;
#ifdef _BENQ_DEBUG
	printf("benq_init_cx_scan_3\n");
#endif
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,10))){
		if(!dev->silent) sperror ("benq_init_cx_scan_3",dev->err);
		return dev->err;
	}

	dev->cmd[0] = 0xF8;
	dev->cmd[8] = 0x02;
#ifdef _BENQ_DEBUG
	printf("benq_init_cx_scan_4\n");
#endif
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,2))){
		if(!dev->silent) sperror ("benq_init_cx_scan_4",dev->err);
		return dev->err;
	}
// ************
	dev->rd_buf[0] = 0xD4;
	dev->rd_buf[1] = 0x91;
	dev->rd_buf[2] = 0x00;
	dev->rd_buf[3] = 0x00;
	dev->rd_buf[4] = 0x00;
	dev->rd_buf[5] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x06;
#ifdef _BENQ_DEBUG
	printf("benq_init_cx_scan_5\n");
#endif
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,6))){
		if(!dev->silent) sperror ("benq_init_cx_scan_5",dev->err);
		return dev->err;
	}

	dev->cmd[0] = 0xF8;
	dev->cmd[8] = 0x02;
#ifdef _BENQ_DEBUG
	printf("benq_init_cx_scan_6\n");
#endif
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,2))){
		if(!dev->silent) sperror ("benq_init_cx_scan_6",dev->err);
		return dev->err;
	}

//	cnt=0;
	return 0;
}


int scan_benq::cmd_dvd_errc_init()
{
	int i;

	dev->cmd[0] = 0xFD;
	dev->cmd[1] = 0xF1;
	dev->cmd[2] = 0x42;
	dev->cmd[3] = 0x45;
	dev->cmd[4] = 0x4E;
	dev->cmd[5] = 0x51;
#ifdef _BENQ_DEBUG
	printf("benq_init_pi_scan_0\n");
#endif
	if ((dev->err=dev->cmd.transport(NONE,NULL,0))){
		if(!dev->silent) sperror ("benq_init_pi_scan_0",dev->err);
		return dev->err;
	}
// ************
	dev->rd_buf[0] = 0xD2;
	dev->rd_buf[1] = 0x0A;
	dev->rd_buf[2] = 0x05;
	dev->rd_buf[3] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x04;
#ifdef _BENQ_DEBUG
	printf("benq_init_pi_scan_1\n");
#endif
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,4))){
		if(!dev->silent) sperror ("benq_init_pi_scan_1",dev->err);
		return dev->err;
	}

	dev->cmd[0] = 0xF8;
	dev->cmd[8] = 0x02;
#ifdef _BENQ_DEBUG
	printf("benq_init_pi_scan_2\n");
#endif
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,2))){
		if(!dev->silent) sperror ("benq_init_pi_scan_2",dev->err);
		return dev->err;
	}
// ************
	dev->rd_buf[0] = 0xC8;
	dev->rd_buf[1] = 0x99;
	dev->rd_buf[2] = 0x79;
	for (i=3; i<10; i++)
		dev->rd_buf[i] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x0A;
#ifdef _BENQ_DEBUG
	printf("benq_init_pi_scan_3\n");
#endif
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,10))){
		if(!dev->silent) sperror ("benq_init_pi_scan_3",dev->err);
		return dev->err;
	}

	dev->cmd[0] = 0xF8;
	dev->cmd[8] = 0x02;
#ifdef _BENQ_DEBUG
	printf("benq_init_pi_scan_4\n");
#endif
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,2))){
		if(!dev->silent) sperror ("benq_init_pi_scan_4",dev->err);
		return dev->err;
	}
// ************
	dev->rd_buf[0] = 0xD4;
	dev->rd_buf[1] = 0x91;
	dev->rd_buf[2] = 0x03;
	dev->rd_buf[3] = 0x00;
	dev->rd_buf[4] = 0x00;
	dev->rd_buf[5] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x06;
#ifdef _BENQ_DEBUG
	printf("benq_init_pi_scan_5\n");
#endif
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,6))){
		if(!dev->silent) sperror ("benq_init_pi_scan_5",dev->err);
		return dev->err;
	}

	dev->cmd[0] = 0xF8;
	dev->cmd[8] = 0x02;
#ifdef _BENQ_DEBUG
	printf("benq_init_pi_scan_6\n");
#endif
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,2))){
		if(!dev->silent) sperror ("benq_init_pi_scan_6",dev->err);
		return dev->err;
	}

//	cnt=0;
	return 0;
}

// ************ Scan commands ***********
int scan_benq::cmd_read_block()
{
	dev->rd_buf[0] = 0xC1;
	dev->rd_buf[1] = 0x9A;
	dev->rd_buf[2] = 0x00;
	dev->rd_buf[3] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x04;
#ifdef _BENQ_DEBUG
	printf("benq_scan_block\n");
#endif
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,4))){
		sperror ("benq_scan_block",dev->err);
		return dev->err;
	}
	return 0;
}

int scan_benq::cmd_getdata()
{
	dev->cmd[0] = 0xF8;
	dev->cmd[7] = 0x01;
	dev->cmd[8] = 0x02;
#ifdef _BENQ_DEBUG
	printf("benq_read_err\n");
#endif
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,258))){
		sperror ("benq_read_err",dev->err);
		return dev->err;
	}
	return 0;
}

// ***********
//  CD tests
// ***********

int scan_benq::cmd_cd_errc_block(cd_errc *data)
{
	int i,m,s,f;
#ifdef _BENQ_DEBUG
	printf("benq_cx_do_one_interval. LBA=%d\n",*lba);
#endif
	int found=0;
	int cnt=128;
	while ((!found) && (cnt)) {
		cmd_read_block();
		cmd_getdata();
		if ((!dev->rd_buf[0]) && (dev->rd_buf[1] == 0x63) && (dev->rd_buf[2] == 0x64) && (dev->rd_buf[3] == 0x6E)) {
			printf("\nData block found...\n");
			found = 1;
		} else {
			printf(".");
//			return 0;
		}
		msleep(1);
		cnt--;
	}
	if (!cnt) return 1;
#ifdef _BENQ_DEBUG2
	for (i=0; i<32; i++) {
		if (!(i%8)) printf("| ");
		printf("%02X ", dev->rd_buf[i] & 0xFF);
	}
	printf("|\n");
#endif

	data->bler = ntoh16(dev->rd_buf+12); // C1
	data->e11 = 0;
	data->e21 = 0;
	data->e31 = 0;
	data->e12 = 0;
	data->e22 = ntoh16(dev->rd_buf+18); // C2
	data->e32 = 0; // CU
//	*lba+=75;
//	cnt++;
	m = ((dev->rd_buf[7] >> 4) & 0x0F)*10 + (dev->rd_buf[7] & 0x0F);
	s = ((dev->rd_buf[8] >> 4) & 0x0F)*10 + (dev->rd_buf[8] & 0x0F);
	f = ((dev->rd_buf[9] >> 4) & 0x0F)*10 + (dev->rd_buf[9] & 0x0F);
	lba = (m*60 + s)*75 + f;
//	printf("MSF: %02d:%02d.00 ; LBA: %d; C1:%4d; C2:%4d\n",m,s,*lba,*BLER,*E22);
	return 0;
}

/*
int benq_jitter_CD_do_one_interval(dev_info* dev, int* lba, int* jitter, short int* beta, int blklen)
{
	benq_scan_block(dev);
	benq_read_err(dev);

	*jitter = 0;
	*beta = 0;
//	*lba=((int)dev->rd_buf[0] * 4500 + (int)dev->rd_buf[3] * 75 + (int)dev->rd_buf[2]);
	*lba = (((dev->rd_buf[7] & 0xF0)*10 + (dev->rd_buf[7] & 0x0F))*60 +  (dev->rd_buf[7] & 0xF0))*10 + (dev->rd_buf[7] & 0x0F);
	return 0;
}
*/

// ***********
// DVD tests
// ***********

int scan_benq::cmd_dvd_errc_block(dvd_errc *data)
{
	int i;
//	int pif;
#ifdef _BENQ_DEBUG
	printf("benq_pie_pif_do_one_interval. LBA=%d\n",*lba);
#endif
	int found=0;
	int cnt=256;
	while ((!found) && (cnt)) {
		cmd_read_block();
		cmd_getdata();
		if ((!dev->rd_buf[0]) && (dev->rd_buf[1] == 0x64) && (dev->rd_buf[2] == 0x76) && (dev->rd_buf[3] == 0x64)) {
			printf("\nData block found...\n");
			found = 1;
		} else {
			printf(".");
//			return 0;
		}
		msleep(1);
		cnt--;
	}
	if (!cnt) return 1;
#ifdef _BENQ_DEBUG2
	for (i=0; i<32; i++) {
		if (!(i%8)) printf("| ");
		printf("%02X ", dev->rd_buf[i] & 0xFF);
	}
	printf("|\n");
#endif
	data->pie = ntoh16(dev->rd_buf+12) + ntoh16(dev->rd_buf+14) + ntoh16(dev->rd_buf+16) + ntoh16(dev->rd_buf+18) + ntoh16(dev->rd_buf+20);
	data->pif = ntoh16(dev->rd_buf+22);
	data->poe = 0;
	data->pof = ntoh16(dev->rd_buf+56);
	lba = (((dev->rd_buf[7]-3) << 16 )& 0xFF0000) + ((dev->rd_buf[8] << 8)&0xFF00 ) + (dev->rd_buf[9] & 0xFF);
//	printf("LBA: %d; PIE:%4d; PIF:%4d\n",*lba,*pie, *pif);
	return 0;
}

/*
int benq_jitter_DVD_do_16_ecc(dev_info* dev, int* lba, int* jitter, short int* beta)
{
	benq_scan_block(dev);
	benq_read_err(dev);

	*jitter = 0;
	*beta = 0;
//	*lba=((int)dev->rd_buf[0] * 4500 + (int)dev->rd_buf[3] * 75 + (int)dev->rd_buf[2]);
	*lba+= 0x400;
	return 0;
}
*/

// ************* END SCAN COMMAND *********
int scan_benq::cmd_cd_end()
{
	int i;

	dev->rd_buf[0] = 0xD4;
	dev->rd_buf[1] = 0x91;
	for (i=2; i<10; i++)
		dev->rd_buf[i] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x0A;
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,10))){
		sperror ("benq_end_scan_0",dev->err);
		return dev->err;
	}

	dev->cmd[0] = 0xF8;
	dev->cmd[8] = 0x02;
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,2))){
		sperror ("benq_end_scan_1",dev->err);
		return dev->err;
	}
// ************
	dev->rd_buf[0] = 0xD4;
	dev->rd_buf[1] = 0x91;
	dev->rd_buf[2] = 0x00;
	dev->rd_buf[3] = 0x02;
	dev->rd_buf[4] = 0x00;
	dev->rd_buf[5] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x06;
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,6))){
		sperror ("benq_end_scan_2",dev->err);
		return dev->err;
	}

	dev->cmd[0] = 0xF8;
	dev->cmd[8] = 0x02;
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,2))){
		sperror ("benq_end_scan_3",dev->err);
		return dev->err;
	}
// ************
	dev->cmd[0] = 0xFD;
	dev->cmd[1] = 0xF2;
	dev->cmd[2] = 0x42;
	dev->cmd[3] = 0x45;
	dev->cmd[4] = 0x4E;
	dev->cmd[5] = 0x51;
	if ((dev->err=dev->cmd.transport(NONE,NULL,0))){
		sperror ("benq_end_scan_4",dev->err);
		return dev->err;
	}
	return 0;
}


int scan_benq::cmd_dvd_end()
{
	int i;

	dev->rd_buf[0] = 0xD4;
	dev->rd_buf[1] = 0x91;
	for (i=2; i<10; i++)
		dev->rd_buf[i] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x0A;
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,10))){
		sperror ("benq_end_scan_0",dev->err);
		return dev->err;
	}

	dev->cmd[0] = 0xF8;
	dev->cmd[8] = 0x02;
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,2))){
		sperror ("benq_end_scan_1",dev->err);
		return dev->err;
	}
// ************
	dev->rd_buf[0] = 0xD4;
	dev->rd_buf[1] = 0x91;
	dev->rd_buf[2] = 0x03;
	dev->rd_buf[3] = 0x00;
	dev->rd_buf[4] = 0x00;
	dev->rd_buf[5] = 0x00;

	dev->cmd[0] = 0xF9;
	dev->cmd[8] = 0x06;
	if ((dev->err=dev->cmd.transport(WRITE,dev->rd_buf,6))){
		sperror ("benq_end_scan_2",dev->err);
		return dev->err;
	}

	dev->cmd[0] = 0xF8;
	dev->cmd[8] = 0x02;
	if ((dev->err=dev->cmd.transport(READ,dev->rd_buf,2))){
		sperror ("benq_end_scan_3",dev->err);
		return dev->err;
	}
// ************
	dev->cmd[0] = 0xFD;
	dev->cmd[1] = 0xF2;
	dev->cmd[2] = 0x42;
	dev->cmd[3] = 0x45;
	dev->cmd[4] = 0x4E;
	dev->cmd[5] = 0x51;
	if ((dev->err=dev->cmd.transport(NONE,NULL,0))){
		sperror ("benq_end_scan_4",dev->err);
		return dev->err;
	}
	return 0;
}

